<template>
  <div class="app-container">
    <!-- 搜索工作栏 -->
    <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="流程名称" prop="name">
        <el-input v-model="queryParams.name" placeholder="请输入流程名称" clearable @keyup.enter.native="handleQuery"/>
      </el-form-item>
   
      <el-form-item label="创建时间" prop="createTime">
        <el-date-picker v-model="queryParams.createTime" style="width: 240px" value-format="yyyy-MM-dd HH:mm:ss" type="daterange"
                        range-separator="-" start-placeholder="开始日期" end-placeholder="结束日期" :default-time="['00:00:00', '23:59:59']" />
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>
    <!-- 列表 -->
    <el-table v-loading="loading" :data="list" @row-click="handleAudit">
      <el-table-column label="任务编号" align="center" prop="id"/>
      <el-table-column label="流程名称" align="center" prop="name" />
      <el-table-column label="创建时间" align="center" prop="startTime" width="180">
        <template v-slot="scope">
          <span>{{ parseTime(scope.row.startTime) }}</span>
        </template>
      </el-table-column>
      <el-table-column label="状态" align="center" prop="status">
        <template v-slot="scope">
          <dict-tag :type="DICT_TYPE.BPM_TASK_AUDIT_STATUS" :value="scope.row.status"/>
        </template>
      </el-table-column>
      <el-table-column label="当前处理人" align="center" prop="currentAuditUser.nickname" />
    </el-table>
    <!-- 分页组件 -->
    <pagination v-show="total > 0" :total="total" :page.sync="queryParams.pageNo" :limit.sync="queryParams.pageSize"
                @pagination="getList"/>
                <el-dialog :title="title" :visible.sync="open" width="800px" append-to-body v-loading="detailLoading">
      <async-biz-form-component :id="businessKey" name="my"></async-biz-form-component>
    </el-dialog>
  </div>
</template>

<script>
import { getMyProcessInstancePage, cancelProcessInstance } from "@/api/bpm/processInstance";
import Vue from "vue";
export default {
  name: "BpmProcessInstance",
  components: {
  },
  data() {
    return {
      detailLoading:false,
      title:'',
        //详情页面id
    businessKey:'',
    open: false,
      // 遮罩层
      loading: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 工作流的流程实例的拓展列表
      list: [],
      // 查询参数
      queryParams: {
        pageNo: 1,
        pageSize: 10,
        name: null,
        createTime: []
      }
    };
  },
  created() {
    this.getList();
  },
  activated() {
    this.getList();
  },
  methods: {
    closeEdit() {
      this.open = false;
      this.getList();
    },
    /** 查询列表 */
    getList() {
      this.loading = true;
      // 执行查询
      getMyProcessInstancePage(this.queryParams).then(response => {
        this.list = response.data.list;
        this.total = response.data.total;
        this.loading = false;
      });
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNo = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
     /** 处理审批按钮 */
   handleAudit(row) {
      this.title = row.name;
      console.log(row);
      this.businessKey = row.businessKey;
       //将业务表单，注册为动态组件
       const path = row.processDefinition.formCustomViewPath;
        console.log("path:" + path)
        Vue.component("async-biz-form-component", function (resolve) {
          require([`@/views${path}`], resolve);
        });
        this.open = true;
    }
  }
};
</script>
